package Galois is
   --P: constant Natural := 16183;
   P: constant Natural := 239;
   Logp: constant Natural := 8;
   R: constant Natural := 2**Logp;
   Exp_K: constant  Natural := 17;
   Exp_2k: constant Natural := 50;
   --P: constant Natural := 2;
   --P: constant Natural := 7;
   --M: constant Natural := 17;
   --M: constant Natural := 8;
   M: constant Natural := 5;
   subtype Natural_Mod_P is Natural range 0 .. P-1;
   type Polynomial is array(0 .. M) of Natural_Mod_P;
   subtype Bit is Natural range 0 .. 1;
   type Bit_Vector is array(0 .. Logp-1) of Bit;
   function Divide_By_2(X, P: in Integer) return Integer;
   function Divide_By_4(X, P: in Integer) return Integer;
   function Degree(A: Polynomial) return Natural;
   function Subtract(A, B: Polynomial) return Polynomial;
   function Invert(Y: Natural_Mod_P) return Natural_Mod_P;
   function Product(A: Polynomial; B: Natural_Mod_P) return Polynomial;
   function Shift_One(A: Polynomial) return Polynomial;
   function Divide_By_X(A, F: Polynomial) return Polynomial;
   function Add(A, B: Polynomial) return Polynomial;
   function Multiply_By_X(A, F: Polynomial) return Polynomial;
   function Product_Mod_F(A, B, F: Polynomial) return Polynomial;
   function Frobenius(J, I: Natural)return Natural_Mod_P;
   function Quotient(Num, Den: Polynomial) return Polynomial;
   function Remainder(Num, Den: Polynomial) return Polynomial;
   function Shift(A: Polynomial; T: Natural) return Polynomial;
   function Shift(A, F: Polynomial; T: Natural) return Polynomial;
   procedure Swap(A, B: in out Polynomial); 
   procedure Swap(S, T: in out Natural); 
   function Mp(X, Y: in Natural) return Natural; 
end Galois;

