---------------------------------------------------------------------------
-- Mod f(x) division. Multiplications over GF(p**m) and inversion over Zp 
---------------------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Galois; use Galois;
procedure Algorithm11 is
   F, G, H, E, A, C, Z, Y: Polynomial;
   B: Natural_Mod_P;
   Q: Natural;
   subtype Bit is Natural range 0 .. 1;
   R_Minus_2: constant Natural := (P**M)-2;   
   function Logarithm(X: Natural) return Natural is
      S: Natural;
   begin
      S := 1;
      while 2**S < R_Minus_2 loop S := S+1; end loop;
      return S;
   end Logarithm;
   S: constant Natural := Logarithm(R_Minus_2);
   type Binary_Representation is array(0 .. S-1) of Bit;
   R: Binary_Representation;
begin
   R(0) := R_Minus_2 mod 2; Q := R_Minus_2/2;
   for I in 1 .. S-1 loop R(I) := Q mod 2; Q := Q/2; end loop;
   for I in 0 .. M loop G(I) := 0; H(I) := 0; F(I) := 0; end loop;
   --F(0) := 237; F(17) := 1;
   --f(0) := 1; f(17) := 1;
   --G(1) := 1; G(5) := 47; G(9) := 230; G(15) := 117;
   --h(3) := 120;
   --F(0) := 237; F(7) := 29; F(14) := 42; F(17) := 1;
   --H(3) := 211; H(9) := 123; H(11) := 7; H(15) := 189;
   F(5) := 1; F(4) := 2; F(3) := 2; F(2) := 4; F(1) := 6; F(0) := 2;
   G(0) := 0; G(1) := 1; G(2) := 2; G(3) := 3; G(4) := 4;
   for I4 in 0 .. 6 loop 
      for I3 in 0 .. 6 loop
         for I2 in 0 .. 6 loop 
            for I1 in 0 .. 6 loop
               for I0 in 0 .. 6 loop 
                  H(4) := I4; H(3) := I3; H(2) := I2; H(1) := I1; H(0) := I0; 
                  ----------------------------------------------------------------------------
                  E(0) := 1; for I in 1 .. M loop E(I) := 0; end loop;
                  for I in 0 .. S-1 loop
                     E := Product_Mod_F(E, E, F);
                     if R(S-1-I) = 1 then E := Product_Mod_F(E, H, F); end if;
                  end loop;
                  A := Product_Mod_F(E, H, F);
                  B := Invert(A(0));
                  C := Product(E, B);
                  Z := Product_Mod_F(C, G, F);
                  -----------------------------------------------------------------------------
                  Y := Product_Mod_F(Z, H, F);
                  Put("z = "); for I in 0 .. M loop Put(Z(I)); Put("  "); end loop; New_Line;
                  Put("z.h = "); for I in 0 .. M loop Put(Y(I)); Put("  "); end loop; New_Line;
                  if Y /=(0,1,2,3,4,0) then Put("ERROR"); end if;
                  New_Line;
               end loop; 
            end loop; 
         end loop; 
      end loop; 
   end loop; 
end Algorithm11;